$(function(){
	initWebGL();
	drawSky();
	
	adjustSize();
	
	renderTick();
	//setInterval(tick, 50);
});

var audio = {
	shoot: new Audio("sound/shoot.ogg"),
	missed: new Audio("sound/missed.ogg"),
	hit: new Audio("sound/hit.ogg"),
	laser: new Audio("sound/laser.ogg"),
}
for(var i in audio){
	audio[i].volume = 0.5;
}
var audioOn = true;
if(getCookie("sound") == "0"){
	audioOn = false;
	$(function(){
		$("div#sound").html("Sound off");
	});
}

var startPoint = 2;
var helpState = 0;
if(getCookie("h") == "1")
	helpState = 2;
else if(getCookie("h") == "2")
	helpState = 4;

var planetSize = 64;
var planetSize2 = planetSize*planetSize;
var optimalSize = planetSize;
var particles = [];
var projectiles = [];
var rProjectiles = [];
var ships = [];
var rShips = [];
var hitShips = [];
var turrets = [{
	a: 0,
	angle: 0,
	pressing: 0,
	t: 0
}, {
	a: -Math.PI,
	angle: 0,
	pressing: 0,
	t: 0
}];
var lasers = [];
var growthTicks = 0;
var hitCount = 0;

var G = 15;
var atmosphere = 30000;
var lastAtmosphere = atmosphere;
var rotation = 0;
var dRotation = 0;
var rRotation = 0;
var walkState = 0;

var time = new Date().getTime();

var keys = {};

function startGame(){
	planetSize = 64;
	planetSize2 = planetSize*planetSize;
	optimalSize = planetSize;
	particles = [];
	projectiles = [];
	rProjectiles = [];
	ships = [];
	rShips = [];
	hitShips = [];
	G = 15;
	atmosphere = 30000;
	lastAtmosphere = atmosphere;
	turrets = [{
		a: 0,
		angle: 0,
		pressing: 0,
		t: 0
	}, {
		a: -Math.PI,
		angle: 0,
		pressing: 0,
		t: 0
	}];
	rotation = 0;
	dRotation = 0;
	hitCount = 0;
}
function renderTick(){
	if(helpState != 1 && helpState != 3 && startPoint != 5){
		var elapsed = (new Date().getTime()-time);
		time = new Date().getTime();
		for(var i=rProjectiles.length-1; i>=0; i--){
			var p = rProjectiles[i];
			
			var d2 = p.x*p.x+p.y*p.y;
			var d = Math.sqrt(d2);
			var a = -elapsed*G/d2;
			
			p.dx += a*p.x/d;
			p.dy += a*p.y/d;
			p.x += elapsed*p.dx;
			p.y += elapsed*p.dy;
		}
		for(var i=rShips.length-1; i>=0; i--){
			var p = rShips[i];
			
			if(p.hit > 0){
				var d2 = p.x*p.x+p.y*p.y;
				var d = Math.sqrt(d2);
				var a = -elapsed*G/d2;
				
				p.dx += a*p.x/d;
				p.dy += a*p.y/d;
			}
			p.x += elapsed*p.dx;
			p.y += elapsed*p.dy;
			p.angle = Math.atan2(p.dy, p.dx)+Math.PI;
		}
		
		for(var i=particles.length-1; i>=0; i--){
			particles[i].life--;
			if(particles[i].life <= 0)
				particles.splice(i, 1);
			else{
				particles[i].x += elapsed*particles[i].dx;
				particles[i].y += elapsed*particles[i].dy;
			}
		}
		
		for(var i=lasers.length-1; i>=0; i--){
			lasers[i].life -= elapsed;
			if(lasers[i].life <= 0)
				lasers.splice(i, 1);
		}
		
		if(planetSize < optimalSize){
			planetSize = Math.min(planetSize+elapsed/50, optimalSize);
			planetSize2 = planetSize*planetSize;
			G = 15/4096*planetSize*planetSize;
			
			changeZoom(4*8/Math.sqrt(planetSize));
			drawSky();
		}
		
		rRotation += elapsed*dRotation;
		walkState += elapsed*dRotation;
		
		updateBuffers();
		changeRotation();
		drawScene();
	}
	
	requestAnimationFrame(renderTick);
}
var lastGrowth = 0;
function tick(){
	if(helpState == 1 || helpState == 3 || startPoint == 5)
		return;
	var atm = atmosphere;
	var elapsed = 50;
	var l, g, p, d2, d, a;
	for(var i=projectiles.length-1; i>=0; i--){
		p = projectiles[i];
		d2 = p.x*p.x+p.y*p.y;
		d = Math.sqrt(d2);
		
		if(d < planetSize){
			var t = 15+Math.random()*15;
			var a = Math.atan2(p.y, p.x), r, b;
			p.x *= planetSize/d;
			p.y *= planetSize/d;
			for(var j=0; j<t; j++){
				l = 75+parseInt(Math.random()*25);
				g = 32+parseInt(Math.random()*64);
				b = a+1.57-3.1415*Math.random();
				r = 30*Math.random();
				particles.push({
					x: p.x+r*Math.cos(b),
					y: p.y+r*Math.sin(b),
					dx: 0,
					dy: 0,
					r: g,
					g: g,
					b: g,
					life: l,
					lifeTime: l,
					size: 10+parseInt(10*Math.random())
				});
			}
			projectiles.splice(i, 1);
			rProjectiles.splice(i, 1);
			playAudio("missed");
			continue;
		}else{
			a = -elapsed*G/d2;
			
			p.dx += a*p.x/d;
			p.dy += a*p.y/d;
			
			p.x += elapsed*p.dx;
			p.y += elapsed*p.dy;
			
			if(p.x > 2*canvas.width/rZoom || p.x < -2*canvas.width/rZoom || p.y > 2*canvas.height/rZoom || p.y < -2*canvas.height/rZoom){
				projectiles.splice(i, 1);
				rProjectiles.splice(i, 1);
				continue;
			}else if(Math.random() < 0.3){
				l = 75+parseInt(Math.random()*25);
				g = 32+parseInt(Math.random()*96);
				particles.push({
					x: p.x-2.5+5*Math.random(),
					y: p.y-2.5+5*Math.random(),
					dx: 0,
					dy: 0,
					r: g,
					g: g,
					b: g,
					life: l,
					lifeTime: l,
					size: 4+parseInt(4*Math.random())
				});
			}
		}
		for(var j in rProjectiles[i])
			rProjectiles[i][j] = projectiles[i][j];
	}
	
	for(var i=ships.length-1; i>=0; i--){
		p = ships[i];
		if(p.hit <= 0){
			p.x += elapsed*p.dx;
			p.y += elapsed*p.dy;
			
			if(p.x > 2*canvas.width/rZoom || p.x < -2*canvas.width/rZoom || p.y > 2*canvas.height/rZoom || p.y < -2*canvas.height/rZoom){
					if(p.hit == 0){
						ships.splice(i, 1);
						rShips.splice(i, 1);
						for(var j in hitShips){
							if(p == hitShips[j]){
								hitShips.splice(j, 1);
								break;
							}
						}
						continue;
					}
			}else{
				p.hit = 0;
				for(var j in projectiles){
					if(Math.abs(p.x-projectiles[j].x) < 30 && Math.abs(p.y-projectiles[j].y) < 30){
						projectiles.splice(j, 1);
						rProjectiles.splice(j, 1);
						playAudio("hit");
						if(!helpState){
							helpState = 1;
							$("#text").html("When you hit a spaceship, it will produce smoke, which will help your atmosphere grow.<br/>Press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span> to continue.");
						}
						hitShips.push(p);
						p.hit = hitShips.length;
						p.dx *= 0.9*64/planetSize;
						p.dy *= 0.9*64/planetSize;
						hitCount++;
						break;
					}
				}
				if(p.hit <= 0)
					for(var j in hitShips){
						if(Math.abs(p.x-hitShips[j].x) < 30 && Math.abs(p.y-hitShips[j].y) < 30){
							projectiles.splice(j, 1);
							rProjectiles.splice(j, 1);
							playAudio("hit");
							if(!helpState){
								helpState = 1;
								$("#text").html("When you hit a spaceship, it will produce smoke, which will help your atmosphere grow.<br/>Press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span> to continue.");
							}
							hitShips.push(p);
							p.hit = hitShips.length;
							hitCount++;
							p.dx *= 0.5*64/planetSize;
							p.dy *= 0.5*64/planetSize;
							break;
						}
					}
			}
		}else{
			d2 = p.x*p.x+p.y*p.y;
			d = Math.sqrt(d2);
			
			if(d < planetSize){
				var t = 35+Math.random()*15;
				var a = Math.atan2(p.y, p.x), r, b;
				p.x *= planetSize/d;
				p.y *= planetSize/d;
				for(var j=0; j<t; j++){
					b = a+1.57-3.1415*Math.random();
					r = 50*Math.random();
					if(Math.random() < 0.6){
						l = 75+parseInt(Math.random()*75);
						particles.push({
							x: p.x+r*Math.cos(b),
							y: p.y+r*Math.sin(b),
							dx: 0.015*Math.cos(b),
							dy: 0.015*Math.sin(b),
							r: 255,
							g: 255*Math.random(),
							b: 0,
							life: l,
							lifeTime: l,
							size: 2+parseInt(3*Math.random())
						});
					}else{
						l = 75+parseInt(Math.random()*55);
						g = 32+parseInt(Math.random()*32);
						particles.push({
							x: p.x+r*Math.cos(b),
							y: p.y+r*Math.sin(b),
							dx: 0.01*Math.cos(b),
							dy: 0.01*Math.sin(b),
							r: g+30*Math.random(),
							g: g+10*Math.random(),
							b: g,
							life: l,
							lifeTime: l,
							size: 10+parseInt(10*Math.random())
						});
					}
				}
				ships.splice(i, 1);
				rShips.splice(i, 1);
				hitShips.splice(p.hit-1, 1);
				for(var j in hitShips){
					if(p == hitShips[j]){
						hitShips.splice(j, 1);
					}
				}
				optimalSize += 5;
				if(Math.random() < 1/Math.sqrt(turrets.length))
					turrets.push({
						a: a-rotation,
						angle: 0,
						pressing: 0,
						t: p.t
					});
				if(helpState == 2){
					helpState = 3;
					$("#text").html("When a spaceShip hits the ground, there's a chance you get a new cannon.<br/>Press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span> to continue.");
				}
				continue;
			}else{
				a = -elapsed*G/d2;
				
				p.dx += a*p.x/d;
				p.dy += a*p.y/d;
				
				p.x += elapsed*p.dx;
				p.y += elapsed*p.dy;
				
				if(p.x > 2*canvas.width/rZoom || p.x < -2*canvas.width/rZoom || p.y > 2*canvas.height/rZoom || p.y < -2*canvas.height/rZoom){
					ships.splice(i, 1);
					rShips.splice(i, 1);
					hitShips.splice(p.hit-1, 1);
					for(var j in hitShips){
						if(p == hitShips[j]){
							hitShips.splice(j, 1);
						}
					}
					continue;
				}else{
					var t = 5+10*Math.random();
					for(var j=0; j<t; j++)
						if(Math.random() < 0.5){
							l = 75+parseInt(Math.random()*25);
							particles.push({
								x: p.x-7+14*Math.random(),
								y: p.y-7+14*Math.random(),
								dx: 0,
								dy: 0,
								r: 255,
								g: 255*Math.random(),
								b: 0,
								life: l,
								lifeTime: l,
								size: 2+parseInt(3*Math.random())
							});
						}else{
							l = 75+parseInt(Math.random()*75);
							g = 32+parseInt(Math.random()*32);
							particles.push({
								x: p.x-10+20*Math.random(),
								y: p.y-10+20*Math.random(),
								dx: 0,
								dy: 0,
								r: g+30*Math.random(),
								g: g+10*Math.random(),
								b: g,
								life: l,
								lifeTime: l,
								size: 10+parseInt(10*Math.random())
							});
						}
					atmosphere += 200/Math.sqrt((d-planetSize+1));
				}
			}
		}
		for(var j in ships[i])
			rShips[i][j] = ships[i][j];
	}
	
	l = 2*Math.sqrt(canvas.width*canvas.width+canvas.height*canvas.height)/rZoom;
	if(Math.random() < 0.05){
		a = 2*Math.PI*Math.random();
		d = planetSize+50+Math.random()*100;
		var s = Math.sin(a), c = Math.cos(a);
		g = 0.3+0.01*(planetSize-64);
		if(Math.random() > 0.5){
			ships.push({
				x: c*d-s*l,
				y: s*d+c*l,
				dx: g*s,
				dy: -g*c,
				hit: -1,
				t: parseInt(1.5*Math.random())
			});
			rShips.push({
				x: c*d-s*l,
				y: s*d+c*l,
				dx: g*s,
				dy: -g*c,
				hit: -1,
				angle: a+Math.PI/2
			});
		}else{
			ships.push({
				x: c*d+s*l,
				y: s*d-c*l,
				dx: -g*s,
				dy: g*c,
				hit: -1,
				t: parseInt(1.5*Math.random())
			});
			rShips.push({
				x: c*d+s*l,
				y: s*d-c*l,
				dx: -g*s,
				dy: g*c,
				hit: -1,
				angle: a-Math.PI/2
			});
		}
	}
	
	if(keys[37]){
		dRotation -= elapsed*0.000005;
	}
	if(keys[39]){
		dRotation += elapsed*0.000005;
	}
	dRotation *= 0.95;
	rotation += elapsed*dRotation;
	rRotation = rotation;
	for(var i in turrets){
		p = turrets[i];
		p.angle = 0.5-1/(1+Math.exp(-1e3*dRotation));
		if(Math.random() < 0.05 && p.pressing > 300){
			if(p.t == 0){
				if(p.pressing > 1500)
					p.pressing = 1500;
				projectiles.push({
					x: (planetSize+8)*Math.cos(p.a+rotation),
					y: (planetSize+8)*Math.sin(p.a+rotation),
					dx: p.pressing*Math.cos(p.a+p.angle+rotation)/1000,
					dy: p.pressing*Math.sin(p.a+p.angle+rotation)/1000
				});
				rProjectiles.push(projectiles[projectiles.length-1]);
				p.pressing = 0;
				playAudio("shoot");
			}else{
				var c = (planetSize+8)*Math.cos(p.a+rotation), s = (planetSize+8)*Math.sin(p.a+rotation), c1 = l*Math.cos(p.a+p.angle+rotation), s1 = l*Math.sin(p.a+p.angle+rotation);
				lasers.push({
					x: c,
					y: s,
					eX: c+c1,
					eY: s+s1,
					life: 500,
					lifeTime: 500
				});
				for(var j in ships){
					if(Math.abs((ships[j].x-c)*s1-(ships[j].y-s)*c1) < 30000){
						playAudio("hit");
						hitShips.push(ships[j]);
						ships[j].hit = hitShips.length-1;
						ships[j].dx *= 0.9*64/planetSize;
						ships[j].dy *= 0.9*64/planetSize;
					}
				}
				p.pressing = 0;
				playAudio("laser");
			}
		}
		p.pressing += elapsed;
	}
	atmosphere -= 40;
	if(atmosphere <= 0){
		growthTicks = 0;
		startPoint = 5;
		$("#text").html("You have ran out of atmosphere.<br/>Your planet had a radius of "+(parseInt(planetSize*0.6538)/10)+"m and you hit "+hitCount+" spaceships.<br/>Press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span> to try again.");
		$("#canvas").addClass("baw");
		return;
	}
	if(planetSize >= 400){
		startPoint = 5;
		$("#text").html("Well done! Your planet is big enough to keep growing on its own!<br/>It has a radius of "+parseInt(planetSize*0.06538)+"m and you've hit "+hitCount+" spaceships!<br/>If you want to play again, press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span>");
		$("#canvas").addClass("baw");
		growTicks = 0;
		return;
	}
	if(planetSize <= lastGrowth){
		growTicks++;
	}else{
		growTicks = 0;
	}
	if(growTicks > 100){
		if(planetSize > 64){
			planetSize -= elapsed/500;
		}else{
			growTicks = 0;
		}
	}
	lastGrowth = planetSize;
	drawSky();
}

var zoom = 4;
var rZoom = zoom;
function adjustSize(){
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;
	framebuffer.width = canvas.width;
	framebuffer.height = canvas.height;
	changeZoom(zoom);
}

var canvas, gl, program, particleProgram, skyProgram, bgProgram;
var miscPositionBuffer, miscTexCoordsBuffer, particlePositionBuffer, particleColorBuffer, screenBuffer, screenBorderBuffer, textureBuffer;
var positionLocation, textureLocation, samplerLocation, resolutionLocation, particlePosLocation, particleColLocation, particleResolutionLocation, skyLocation, skyZoomLocation, skySizeLocation, bgPosLocation, bgCoordLocation, bgAtmosphereLocation;
var framebuffer, skyTexture, planetTexture;
var textureSize = 0;
function initWebGL(){
	canvas = $("#canvas")[0];
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;
	gl = getWebGLContext(canvas);
	
	//gl.enable(gl.DEPTH_TEST);
	gl.enable(gl.BLEND);
	gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
	
	var vertexShader = createShaderFromScriptElement(gl, "vertex-shader");
	var fragmentShader = createShaderFromScriptElement(gl, "fragment-shader");
	program = createProgram(gl, [vertexShader, fragmentShader]);
	
	vertexShader = createShaderFromScriptElement(gl, "sky-vertex-shader");
	fragmentShader = createShaderFromScriptElement(gl, "sky-fragment-shader");
	skyProgram = createProgram(gl, [vertexShader, fragmentShader]);
	
	vertexShader = createShaderFromScriptElement(gl, "particle-vertex-shader");
	fragmentShader = createShaderFromScriptElement(gl, "particle-fragment-shader");
	particleProgram = createProgram(gl, [vertexShader, fragmentShader]);
	
	vertexShader = createShaderFromScriptElement(gl, "bg-vertex-shader");
	fragmentShader = createShaderFromScriptElement(gl, "bg-fragment-shader");
	bgProgram = createProgram(gl, [vertexShader, fragmentShader]);
	
	positionLocation = gl.getAttribLocation(program, "a_position");
	textureLocation = gl.getAttribLocation(program, "a_texCoords");
	samplerLocation = gl.getUniformLocation(program, "u_sampler");
	resolutionLocation = gl.getUniformLocation(program, "u_resolution");
	
	particlePosLocation = gl.getAttribLocation(particleProgram, "a_position");
	particleColLocation = gl.getAttribLocation(particleProgram, "a_color");
	particleResolutionLocation = gl.getUniformLocation(particleProgram, "u_resolution");
	
	skyLocation = gl.getAttribLocation(skyProgram, "a_position");
	skyZoomLocation = gl.getUniformLocation(skyProgram, "u_resolution");
	skySizeLocation = gl.getUniformLocation(skyProgram, "u_planetSize2");
	
	bgPosLocation = gl.getAttribLocation(bgProgram, "a_position");
	bgCoordLocation = gl.getAttribLocation(bgProgram, "a_pos");
	bgAtmosphereLocation = gl.getUniformLocation(bgProgram, "u_atmosphere");
	
	miscPositionBuffer = gl.createBuffer();
	miscTexCoordsBuffer = gl.createBuffer();
	particlePositionBuffer = gl.createBuffer();
	particleColorBuffer = gl.createBuffer();
	screenBuffer = gl.createBuffer();
	screenBorderBuffer = gl.createBuffer();
	textureBuffer = gl.createBuffer();
	
	framebuffer = gl.createFramebuffer();
	gl.bindFramebuffer(gl.FRAMEBUFFER, framebuffer);
	framebuffer.width = canvas.width;
	framebuffer.height = canvas.height;
	
	skyTexture = gl.createTexture();
	gl.bindTexture(gl.TEXTURE_2D, skyTexture);
	gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
	gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
	textureSize = min2pow(framebuffer.width, framebuffer.height);
	gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, textureSize, textureSize, 0, gl.RGBA, gl.UNSIGNED_BYTE, null);
	
	var pos = [
		-1.0, -1.0, 0.0,
		-1.0, +1.0, 0.0,
		+1.0, -1.0, 0.0,
		-1.0, +1.0, 0.0,
		+1.0, -1.0, 0.0,
		+1.0, +1.0, 0.0
	];
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(pos), gl.STATIC_DRAW);
	
	changeZoom(4);
	
	var texture = gl.createTexture();
	texture.image = new Image();
	texture.image.onload = function(){
		gl.activeTexture(gl.TEXTURE1);
		gl.bindTexture(gl.TEXTURE_2D, texture);
		gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL, true);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, texture.image);
		
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
		
		gl.activeTexture(gl.TEXTURE0);
		//gl.bindTexture(gl.TEXTURE_2D, skyTexture);
		console.log("Loaded tex");
	}
	texture.image.src = "img/textures.png";
}

function drawSky(){
	gl.bindFramebuffer(gl.FRAMEBUFFER, framebuffer);
	gl.useProgram(skyProgram);
	
	gl.viewport(0, 0, Math.ceil(4*canvas.width/rZoom)/4, Math.ceil(4*canvas.height/rZoom)/4);
    
	gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, skyTexture, 0);
	gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
	
	gl.uniform2f(skyZoomLocation, 2*canvas.width/rZoom, 2*canvas.height/rZoom);
	gl.uniform1f(skySizeLocation, planetSize2);
	lastAtmosphere = atmosphere;
	
	gl.enableVertexAttribArray(skyLocation);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBuffer);
	gl.vertexAttribPointer(skyLocation, 3, gl.FLOAT, false, 0, 0);
	gl.drawArrays(gl.TRIANGLES, 0, 6);
	
	gl.enableVertexAttribArray(skyLocation);
	
	gl.bindFramebuffer(gl.FRAMEBUFFER, null);
	gl.viewport(0, 0, canvas.width, canvas.height);
}
function changeZoom(z){
	zoom = z;
	rZoom = Math.max(1.0, Math.min(4.0, z+1.0));
	
	pos = [
		-2*canvas.width/rZoom, -2*canvas.height/rZoom,
		-2*canvas.width/rZoom, +2*canvas.height/rZoom,
		+2*canvas.width/rZoom, -2*canvas.height/rZoom,
		-2*canvas.width/rZoom, +2*canvas.height/rZoom,
		+2*canvas.width/rZoom, -2*canvas.height/rZoom,
		+2*canvas.width/rZoom, +2*canvas.height/rZoom,
	];
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBorderBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(pos), gl.STATIC_DRAW);
}
function changeRotation(){
	var posV = [
		-framebuffer.width/(2*rZoom*textureSize), -framebuffer.height/(2*rZoom*textureSize),
		-framebuffer.width/(2*rZoom*textureSize), framebuffer.height/(2*rZoom*textureSize),
		+framebuffer.width/(2*rZoom*textureSize), -framebuffer.height/(2*rZoom*textureSize),
		-framebuffer.width/(2*rZoom*textureSize), framebuffer.height/(2*rZoom*textureSize),
		+framebuffer.width/(2*rZoom*textureSize), -framebuffer.height/(2*rZoom*textureSize),
		+framebuffer.width/(2*rZoom*textureSize), framebuffer.height/(2*rZoom*textureSize)
	];
	var pos = [];
	var s = Math.sin(-rRotation), c = Math.cos(rRotation);
	for(var i=0; i<12; i+=2){
		pos[i] = framebuffer.width/(2*rZoom*textureSize)+c*posV[i]-s*posV[i+1];
		pos[i+1] = framebuffer.height/(2*rZoom*textureSize)+s*posV[i]+c*posV[i+1];
	}
	gl.bindBuffer(gl.ARRAY_BUFFER, textureBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(pos), gl.STATIC_DRAW);
}

function updateBuffers(){
	var pos = [];
	var tex = [];
	var c, s, a, b;
	var t, sp, cp;
	for(var i=0; i<turrets.length; i++){
		t = turrets[i];
		sp = Math.sin(t.a+rRotation), cp = Math.cos(t.a+rRotation);
		s = Math.sin(t.a+t.angle+rRotation), c = Math.cos(t.a+t.angle+rRotation);
		a = planetSize+8;
		pos = pos.concat([
			a*cp+12*s-8*c,  a*sp-12*c-8*s,  0.0,
			a*cp-12*s-8*c,  a*sp+12*c-8*s,  0.0,
			a*cp+12*s+16*c, a*sp-12*c+16*s, 0.0,
			a*cp-12*s-8*c,  a*sp+12*c-8*s,  0.0,
			a*cp+12*s+16*c, a*sp-12*c+16*s, 0.0,
			a*cp-12*s+16*c, a*sp+12*c+16*s, 0.0,
			
			planetSize*cp+8*sp-2*cp,  planetSize*sp-8*cp-2*sp,  0.0,
			planetSize*cp-8*sp-2*cp,  planetSize*sp+8*cp-2*sp,  0.0,
			planetSize*cp+8*sp+16*cp, planetSize*sp-8*cp+16*sp, 0.0,
			planetSize*cp-8*sp-2*cp,  planetSize*sp+8*cp-2*sp,  0.0,
			planetSize*cp+8*sp+16*cp, planetSize*sp-8*cp+16*sp, 0.0,
			planetSize*cp-8*sp+16*cp, planetSize*sp+8*cp+16*sp, 0.0,
		]);
		if(t.t == 0)
			tex = tex.concat([
				0.3125, 0.8125,
				0.5,    0.8125,
				0.3125, 1.0,
				0.5,    0.8125,
				0.3125, 1.0,
				0.5,    1.0,
				
				0.15625, 0.859375,
				0.28125, 0.859375,
				0.15625, 1.0,
				0.28125, 0.859375,
				0.15625, 1.0,
				0.28125, 1.0,
			]);
		else
			tex = tex.concat([
				0.0,   0.0,
				0.125, 0.0,
				0.0,   0.185,
				0.125, 0.0,
				0.0,   0.185,
				0.125, 0.185,
				
				0.15625, 0.859375,
				0.28125, 0.859375,
				0.15625, 1.0,
				0.28125, 0.859375,
				0.15625, 1.0,
				0.28125, 1.0,
			]);
	}
	for(var i=0; i<rProjectiles.length; i++){
		pos = pos.concat([
			rProjectiles[i].x-4.0, rProjectiles[i].y-4.0, 0.0,
			rProjectiles[i].x+4.0, rProjectiles[i].y-4.0, 0.0,
			rProjectiles[i].x-4.0, rProjectiles[i].y+4.0, 0.0,
			rProjectiles[i].x+4.0, rProjectiles[i].y-4.0, 0.0,
			rProjectiles[i].x-4.0, rProjectiles[i].y+4.0, 0.0,
			rProjectiles[i].x+4.0, rProjectiles[i].y+4.0, 0.0
		]);
		tex = tex.concat([
			0.0,   0.875,
			0.125, 0.875,
			0.0,   1.0,
			0.125, 0.875,
			0.0,   1.0,
			0.125, 1.0
		]);
	}
	var tP = [];
	for(var i=0; i<rShips.length; i++){
		c = Math.cos(rShips[i].angle);
		s = Math.sin(rShips[i].angle);
		pos = pos.concat([
			rShips[i].x-24*c+12*s, rShips[i].y-24*s-12*c, 0.0,
			rShips[i].x+24*c+12*s, rShips[i].y+24*s-12*c, 0.0,
			rShips[i].x-24*c-12*s, rShips[i].y-24*s+12*c, 0.0,
			rShips[i].x+24*c+12*s, rShips[i].y+24*s-12*c, 0.0,
			rShips[i].x-24*c-12*s, rShips[i].y-24*s+12*c, 0.0,
			rShips[i].x+24*c-12*s, rShips[i].y+24*s+12*c, 0.0,
		]);
		if(ships[i].t == 0)
			tex = tex.concat([
				0.0, 0.5,
				0.5, 0.5,
				0.0, 0.75,
				0.5, 0.5,
				0.0, 0.75,
				0.5, 0.75
			]);
		else
			tex = tex.concat([
				0.0, 0.25,
				0.5, 0.25,
				0.0, 0.5,
				0.5, 0.25,
				0.0, 0.5,
				0.5, 0.5
			]);
		//console.log("D");
	}
	
	if(dRotation < 0)
		pos = pos.concat([
			-5.0, planetSize,      0.0,
			+5.0, planetSize,      0.0,
			-5.0, planetSize+26.0, 0.0,
			+5.0, planetSize,      0.0,
			-5.0, planetSize+26.0, 0.0,
			+5.0, planetSize+26.0, 0.0,
		]);
	else
		pos = pos.concat([
			+5.0, planetSize,      0.0,
			-5.0, planetSize,      0.0,
			+5.0, planetSize+26.0, 0.0,
			-5.0, planetSize,      0.0,
			+5.0, planetSize+26.0, 0.0,
			-5.0, planetSize+26.0, 0.0,
		]);

	if(Math.abs(dRotation) > 1e-3)
		switch(Math.abs(parseInt(walkState*2))%5){
			case 0:
				tex = tex.concat([
					0.53125,  0.796875, 
					0.609375, 0.796875,
					0.53125,  1.0,
					0.609375, 0.796875,
					0.53125,  1.0,
					0.609375, 1.0,
				]);
				break;
			case 1:
				tex = tex.concat([
					0.609375,  0.796875, 
					0.6875, 0.796875,
					0.609375,  1.0,
					0.6875, 0.796875,
					0.609375,  1.0,
					0.6875, 1.0,
				]);
				break;
			case 2:
				tex = tex.concat([
					0.6875,  0.796875, 
					0.765625, 0.796875,
					0.6875,  1.0,
					0.765625, 0.796875,
					0.6875,  1.0,
					0.765625, 1.0,
				]);
				break;
			case 3:
				tex = tex.concat([
					0.765625,  0.796875, 
					0.84375, 0.796875,
					0.765625,  1.0,
					0.84375, 0.796875,
					0.765625,  1.0,
					0.84375, 1.0,
				]);
				break;
			case 4:
				tex = tex.concat([
					0.53125,  0.578125, 
					0.609375, 0.578125,
					0.53125,  0.78125,
					0.609375, 0.578125,
					0.53125,  0.78125,
					0.609375, 0.78125,
				]);
				break;
		}
	else
		tex = tex.concat([
			0.609375,  0.578125, 
			0.6875, 0.578125,
			0.609375,  0.78125,
			0.6875, 0.578125,
			0.609375,  0.78125,
			0.6875, 0.78125,
		]);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, miscPositionBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(pos), gl.STATIC_DRAW);
	gl.bindBuffer(gl.ARRAY_BUFFER, miscTexCoordsBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(tex), gl.STATIC_DRAW);
	
	var pos = [];
	var col = [];
	for(var i=0, j=0, k=0; i<particles.length; i++, j+=3, k+=4){
		pos[j] = particles[i].x;
		pos[j+1] = particles[i].y;
		pos[j+2] = particles[i].size;
		col[k] = particles[i].r;
		col[k+1] = particles[i].g;
		col[k+2] = particles[i].b;
		col[k+3] = parseInt(255*particles[i].life/particles[i].lifeTime);
	}
	for(var i=0, j=particles.length*3, k=particles.length*4; i<lasers.length; i++, j+=6, k+=8){
		pos[j] = lasers[i].x;
		pos[j+1] = lasers[i].y;
		pos[j+2] = 2.0;
		pos[j+3] = lasers[i].eX;
		pos[j+4] = lasers[i].eY;
		pos[j+5] = 2.0;
		col[k] = 255;
		col[k+1] = 0;
		col[k+2] = 0;
		col[k+3] = parseInt(255*lasers[i].life/lasers[i].lifeTime);
		col[k+4] = 255;
		col[k+5] = 0;
		col[k+6] = 0;
		col[k+7] = parseInt(255*lasers[i].life/lasers[i].lifeTime);
	}
	
	gl.bindBuffer(gl.ARRAY_BUFFER, particlePositionBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(pos), gl.STATIC_DRAW);
	gl.bindBuffer(gl.ARRAY_BUFFER, particleColorBuffer);
	gl.bufferData(gl.ARRAY_BUFFER, new Uint8Array(col), gl.STATIC_DRAW);
}


function drawScene(){
	gl.useProgram(bgProgram);
	
	var a = ((2.7*planetSize)/rZoom);
	gl.uniform2f(bgAtmosphereLocation, 2*atmosphere, a*a);
	
	gl.enableVertexAttribArray(bgPosLocation);
	gl.enableVertexAttribArray(bgCoordLocation);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBuffer);
	gl.vertexAttribPointer(bgPosLocation, 3, gl.FLOAT, false, 0, 0);
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBorderBuffer);
	gl.vertexAttribPointer(bgCoordLocation, 2, gl.FLOAT, false, 0, 0);
	gl.drawArrays(gl.TRIANGLES, 0, 6);
	
	gl.disableVertexAttribArray(bgPosLocation);
	gl.disableVertexAttribArray(bgCoordLocation);
	
	gl.useProgram(program);
	
	gl.enableVertexAttribArray(positionLocation);
	gl.enableVertexAttribArray(textureLocation);
	
	gl.uniform2f(resolutionLocation, 2*canvas.width/rZoom, 2*canvas.height/rZoom);
	gl.uniform1i(samplerLocation, 1);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, miscPositionBuffer);
	gl.vertexAttribPointer(positionLocation, 3, gl.FLOAT, false, 0, 0);
	gl.bindBuffer(gl.ARRAY_BUFFER, miscTexCoordsBuffer);
	gl.vertexAttribPointer(textureLocation, 2, gl.FLOAT, false, 0, 0);
	gl.drawArrays(gl.TRIANGLES, 12*turrets.length, 6*(rProjectiles.length+rShips.length));
	
	gl.disableVertexAttribArray(positionLocation);
	gl.disableVertexAttribArray(textureLocation);
	
	gl.useProgram(particleProgram);
	
	gl.uniform2f(particleResolutionLocation, 2*canvas.width/rZoom, 2*canvas.height/rZoom);
	
	gl.enableVertexAttribArray(particlePosLocation);
	gl.enableVertexAttribArray(particleColLocation);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, particlePositionBuffer);
	gl.vertexAttribPointer(particlePosLocation, 3, gl.FLOAT, false, 0, 0);
	gl.bindBuffer(gl.ARRAY_BUFFER, particleColorBuffer);
	gl.vertexAttribPointer(particleColLocation, 4, gl.UNSIGNED_BYTE, true, 0, 0);
	gl.drawArrays(gl.POINTS, 0, particles.length);
	gl.drawArrays(gl.LINES, particles.length, 2*lasers.length);
	
	gl.disableVertexAttribArray(particlePosLocation);
	gl.disableVertexAttribArray(particleColLocation);
	
	gl.useProgram(program);
	
	gl.enableVertexAttribArray(positionLocation);
	gl.enableVertexAttribArray(textureLocation);
	
	
	gl.uniform2f(resolutionLocation, 2*canvas.width/rZoom, 2*canvas.height/rZoom);
	gl.uniform1i(samplerLocation, 1);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, miscPositionBuffer);
	gl.vertexAttribPointer(positionLocation, 3, gl.FLOAT, false, 0, 0);
	gl.bindBuffer(gl.ARRAY_BUFFER, miscTexCoordsBuffer);
	gl.vertexAttribPointer(textureLocation, 2, gl.FLOAT, false, 0, 0);
	gl.drawArrays(gl.TRIANGLES, 0, 12*turrets.length);
	gl.drawArrays(gl.TRIANGLES, 12*turrets.length+6*(rProjectiles.length+rShips.length), 6);
	
	
	gl.uniform2f(resolutionLocation, 1., 1.);
	gl.uniform1i(samplerLocation, 0);
	
	gl.bindBuffer(gl.ARRAY_BUFFER, screenBuffer);
	gl.vertexAttribPointer(positionLocation, 3, gl.FLOAT, false, 0, 0);
	gl.bindBuffer(gl.ARRAY_BUFFER, textureBuffer);
	gl.vertexAttribPointer(textureLocation, 2, gl.FLOAT, false, 0, 0);
	gl.drawArrays(gl.TRIANGLES, 0, 6);
	
	gl.disableVertexAttribArray(positionLocation);
	gl.disableVertexAttribArray(textureLocation);
}


function makeProjection(w, h, d){
	return [
		2/w, 0,   0,   0,
		0,   2/h, 0,   0,
		0,   0,   2/d, 0,
		-1,  -1,   0,   1
	];
}
function makeTranslation(x,y){
	return [
		1, 0, 0, 0,
		0, 1, 0, 0,
		0, 0, 1, 0,
		x, y, 0, 1
	];
}
function makeRotation(a){
	c=Math.cos(a);
	s=Math.sin(a);
	return [
		 c, s, 0, 0,
		-s, c, 0, 0,
		 0, 0, 1, 0,
		 0, 0, 0, 1
	];
}
function makeScale(s){
	return [
		s, 0, 0, 0,
		0, s, 0, 0,
		0, 0, s, 0,
		0, 0, 0, 1
	]
}
function matProd(a,b){
	var a00 = a[0*4+0];
	var a01 = a[0*4+1];
	var a02 = a[0*4+2];
	var a03 = a[0*4+3];
	var a10 = a[1*4+0];
	var a11 = a[1*4+1];
	var a12 = a[1*4+2];
	var a13 = a[1*4+3];
	var a20 = a[2*4+0];
	var a21 = a[2*4+1];
	var a22 = a[2*4+2];
	var a23 = a[2*4+3];
	var a30 = a[3*4+0];
	var a31 = a[3*4+1];
	var a32 = a[3*4+2];
	var a33 = a[3*4+3];
	var b00 = b[0*4+0];
	var b01 = b[0*4+1];
	var b02 = b[0*4+2];
	var b03 = b[0*4+3];
	var b10 = b[1*4+0];
	var b11 = b[1*4+1];
	var b12 = b[1*4+2];
	var b13 = b[1*4+3];
	var b20 = b[2*4+0];
	var b21 = b[2*4+1];
	var b22 = b[2*4+2];
	var b23 = b[2*4+3];
	var b30 = b[3*4+0];
	var b31 = b[3*4+1];
	var b32 = b[3*4+2];
	var b33 = b[3*4+3];
	return [a00 * b00 + a01 * b10 + a02 * b20 + a03 * b30,
			a00 * b01 + a01 * b11 + a02 * b21 + a03 * b31,
			a00 * b02 + a01 * b12 + a02 * b22 + a03 * b32,
			a00 * b03 + a01 * b13 + a02 * b23 + a03 * b33,
			a10 * b00 + a11 * b10 + a12 * b20 + a13 * b30,
			a10 * b01 + a11 * b11 + a12 * b21 + a13 * b31,
			a10 * b02 + a11 * b12 + a12 * b22 + a13 * b32,
			a10 * b03 + a11 * b13 + a12 * b23 + a13 * b33,
			a20 * b00 + a21 * b10 + a22 * b20 + a23 * b30,
			a20 * b01 + a21 * b11 + a22 * b21 + a23 * b31,
			a20 * b02 + a21 * b12 + a22 * b22 + a23 * b32,
			a20 * b03 + a21 * b13 + a22 * b23 + a23 * b33,
			a30 * b00 + a31 * b10 + a32 * b20 + a33 * b30,
			a30 * b01 + a31 * b11 + a32 * b21 + a33 * b31,
			a30 * b02 + a31 * b12 + a32 * b22 + a33 * b32,
			a30 * b03 + a31 * b13 + a32 * b23 + a33 * b33];
}
function min2pow(w, h){
	var p = 1;
	while(p < w || p < h){
		p *= 2;
	}
	return p;
}

function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires+"; path=/";
}
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
}

$(document).keydown(function(e){
	if(startPoint == 2 && (e.keyCode == 39 || e.keyCode == 37) && !keys[e.keyCode]){
		$("#text").html("The cannon will shoot randomly.<br/>You must try to hit the spaceships.<br/>When they collide with the planet, the planet will grow.<br/>Press <span class='key'>&larr;</span> or <span class='key'>&rarr;</span> to begin.");
		startPoint = 3;
	}else if(startPoint == 3 && (e.keyCode == 39 || e.keyCode == 37) && !keys[e.keyCode]){
		$("#text").html("");
		setInterval(tick, 50);
		startPoint = 4;
	}else if(helpState == 1 && (e.keyCode == 39 || e.keyCode == 37) && !keys[e.keyCode]){
		$("#text").html("");
		helpState = 2;
		setCookie("h", "1", 5);
	}else if(helpState == 3 && (e.keyCode == 39 || e.keyCode == 37) && !keys[e.keyCode]){
		$("#text").html("");
		helpState = 4;
		setCookie("h", "2", 5);
	}else if(startPoint == 5 && (e.keyCode == 39 || e.keyCode == 37) && !keys[e.keyCode]){
		$("#text").html("");
		$("#canvas").removeClass("baw");
		startPoint = 4;
		startGame();
	}
	keys[e.keyCode] = true;
})
$(document).keyup(function(e){
	keys[e.keyCode] = false;
});
function toggleSound(){
	if(audioOn){
		audioOn = false;
		$("#sound").html("Sound off");
		setCookie("sound", "0", 5);
	}else{
		audioOn = true;
		$("#sound").html("Sound on");
		setCookie("sound", "1", 5);
	}
}

function playAudio(a){
	if(audioOn){
		audio[a].currentTime = 0;
		audio[a].play();
	}
}
$(window).resize(function(e){
	adjustSize();
});